diff --git a/src/dbus-objects/bonding.c b/src/dbus-objects/bonding.c
index 22cf67945..e3d65a60a 100644
--- a/src/dbus-objects/bonding.c
+++ b/src/dbus-objects/bonding.c
@@ -412,181 +412,97 @@ __ni_objectmodel_bonding_set_arpmon(ni_dbus_object_t *object,
 }
 
 /*
- * Helper for bond slave info
+ * Bonding port (link-request) configuration
  */
-static dbus_bool_t
-__ni_objectmodel_bonding_slave_info_to_dict(const ni_bonding_slave_t *slave, ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_get_bonding_port_config(const ni_bonding_port_config_t *conf,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
-	if (!slave || !slave->info || !dict)
-		return FALSE;
-
-	if (slave->info->state != -1U)
-		ni_dbus_dict_add_uint32(dict, "state", slave->info->state);
-
-	if (slave->info->mii_status != -1U)
-		ni_dbus_dict_add_uint32(dict, "mii-status", slave->info->mii_status);
-
-	if (slave->info->perm_hwaddr.type == ARPHRD_ETHER && slave->info->perm_hwaddr.len)
-		__ni_objectmodel_dict_add_hwaddr(dict, "perm-hwaddr", &slave->info->perm_hwaddr);
+	(void)error;
 
-	if (slave->info->link_failure_count)
-		ni_dbus_dict_add_uint32(dict, "link-failures", slave->info->link_failure_count);
-
-	if (slave->info->queue_id != -1U)
-		ni_dbus_dict_add_uint16(dict, "queue-id", slave->info->queue_id);
+	if (!conf || !dict)
+		return FALSE;
 
-	if (slave->info->ad_aggregator_id != -1U)
-		ni_dbus_dict_add_uint16(dict, "ad-aggregator-id", slave->info->ad_aggregator_id);
+	if (conf->queue_id != -1U)
+		ni_dbus_dict_add_uint16(dict, "queue-id", conf->queue_id);
 
 	return TRUE;
 }
-
-static dbus_bool_t
-__ni_objectmodel_bonding_slave_info_from_dict(ni_bonding_slave_t *slave, const ni_dbus_variant_t *dict, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_set_bonding_port_config(ni_bonding_port_config_t *conf,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
-	uint32_t u32;
 	uint16_t u16;
 
-	if (!slave || !dict)
-		return FALSE;
-
-	if (dict->array.len == 0)
-		return TRUE;
+	(void)error;
 
-	if (slave->info)
-		ni_bonding_slave_info_reset(slave->info);
-	else if (!(slave->info = ni_bonding_slave_info_new()))
+	if (!conf || !dict)
 		return FALSE;
 
-	if (ni_dbus_dict_get_uint32(dict, "state", &u32))
-		slave->info->state = u32;
-
-	if (ni_dbus_dict_get_uint32(dict, "mii-status", &u32))
-		slave->info->mii_status = u32;
-
-	if (__ni_objectmodel_dict_get_hwaddr(dict, "perm-hwaddr", &slave->info->perm_hwaddr)) {
-		if (slave->info->perm_hwaddr.len == ni_link_address_length(ARPHRD_ETHER))
-			slave->info->perm_hwaddr.type = ARPHRD_ETHER;
-	}
-
-	if (ni_dbus_dict_get_uint32(dict, "link-failures", &u32))
-		slave->info->link_failure_count = u32;
-
 	if (ni_dbus_dict_get_uint16(dict, "queue-id", &u16))
-		slave->info->queue_id = u16;
-
-	if (ni_dbus_dict_get_uint16(dict, "ad-aggregator-id", &u16))
-		slave->info->ad_aggregator_id = u16;
+		conf->queue_id = u16;
 
 	return TRUE;
 }
 
 /*
- * Get/set the list of slaves
+ * Bonding port interface info properties
  */
-static dbus_bool_t
-__ni_objectmodel_bonding_get_slaves(const ni_dbus_object_t *object,
-				const ni_dbus_property_t *property,
-				ni_dbus_variant_t *result,
-				DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_get_bonding_port_info(const ni_bonding_port_info_t *info,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
-	const ni_bonding_t *bond;
-	unsigned int i;
+	(void)error;
 
-	if (!(bond = __ni_objectmodel_bonding_read_handle(object, error)))
+	if (!info || !dict)
 		return FALSE;
 
-	ni_dbus_dict_array_init(result);
-	for (i = 0; i < bond->slaves.count; ++i) {
-		const ni_bonding_slave_t *slave = bond->slaves.data[i];
-		const char *slave_name;
-		ni_dbus_variant_t *dict;
-
-		/* should not happen, but better safe than sorry */
-		if (!slave || ni_string_empty(slave->device.name))
-			continue;
-
-		slave_name = slave->device.name;
-		dict = ni_dbus_dict_array_add(result);
-
-		ni_dbus_dict_add_string(dict, "device", slave_name);
-		if (bond->primary_slave.name && ni_string_eq(bond->primary_slave.name, slave_name))
-			ni_dbus_dict_add_bool(dict, "primary", TRUE);
-		if (bond->active_slave.name && ni_string_eq(bond->active_slave.name, slave_name))
-			ni_dbus_dict_add_bool(dict, "active", TRUE);
-
-		__ni_objectmodel_bonding_slave_info_to_dict(slave, dict, error);
-	}
+	if (info->state != -1U)
+		ni_dbus_dict_add_uint32(dict, "state", info->state);
+	if (info->mii_status != -1U)
+		ni_dbus_dict_add_uint32(dict, "mii-status", info->mii_status);
+	if (info->queue_id != -1U)
+		ni_dbus_dict_add_uint16(dict, "queue-id", info->queue_id);
+	if (info->link_failure_count)
+		ni_dbus_dict_add_uint32(dict, "link-failures", info->link_failure_count);
+	if (info->perm_hwaddr.len)
+		__ni_objectmodel_dict_add_hwaddr(dict, "perm-hwaddr", &info->perm_hwaddr);
+	if (info->ad_aggregator_id != -1U)
+		ni_dbus_dict_add_uint16(dict, "ad-aggregator-id", info->ad_aggregator_id);
 
 	return TRUE;
 }
-
-static dbus_bool_t
-__ni_objectmodel_bonding_set_slaves(ni_dbus_object_t *object,
-				const ni_dbus_property_t *property,
-				const ni_dbus_variant_t *result,
-				DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_set_bonding_port_info(ni_bonding_port_info_t *info,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
-	ni_bonding_t *bond;
-	ni_dbus_variant_t *var;
-	unsigned int i;
+	uint32_t u32;
+	uint16_t u16;
 
-	if (!(bond = __ni_objectmodel_bonding_write_handle(object, error)))
-		return FALSE;
+	(void)error;
 
-	if (!ni_dbus_variant_is_dict_array(result)) {
-		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-				"%s.%s property - expected dict array",
-				object->path, property->name);
+	if (!info || !dict)
 		return FALSE;
-	}
 
-	ni_netdev_ref_destroy(&bond->primary_slave);
-	ni_netdev_ref_destroy(&bond->active_slave);
-	ni_bonding_slave_array_destroy(&bond->slaves);
-	for (i = 0, var = result->variant_array_value; i < result->array.len; ++i, ++var) {
-		dbus_bool_t is_primary = FALSE;
-		dbus_bool_t is_active = FALSE;
-		ni_bonding_slave_t *slave;
-		const char *slave_name;
-
-		if (!ni_dbus_dict_get_string(var, "device", &slave_name) ||
-				ni_string_empty(slave_name)) {
-			dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-					"%s.%s property - missing device attribute",
-					object->path, property->name);
-			return FALSE;
-		}
-		if (ni_bonding_has_slave(bond, slave_name)) {
-			dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-				"%s.%s property - duplicate slave device %s",
-				object->path, property->name, slave_name);
-			return FALSE;
-		}
-
-		if (ni_dbus_dict_get_bool(var, "primary", &is_primary) && is_primary) {
-			if (bond->primary_slave.name) {
-				dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-					"%s.%s property - duplicate primary device",
-					object->path, property->name);
-				return FALSE;
-			}
-			ni_string_dup(&bond->primary_slave.name, slave_name);
-		}
-		if (ni_dbus_dict_get_bool(var, "active", &is_active) && is_active) {
-			if (bond->active_slave.name) {
-				dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-					"%s.%s property - duplicate active device",
-					object->path, property->name);
-				return FALSE;
-			}
-			ni_string_dup(&bond->active_slave.name, slave_name);
-		}
-
-		slave = ni_bonding_add_slave(bond, slave_name);
-		if (slave)
-			__ni_objectmodel_bonding_slave_info_from_dict(slave, var, error);
+	if (ni_dbus_dict_get_uint32(dict, "state", &u32))
+		info->state = u32;
+	if (ni_dbus_dict_get_uint32(dict, "mii-status", &u32))
+		info->mii_status = u32;
+	if (ni_dbus_dict_get_uint32(dict, "link-failures", &u32))
+		info->link_failure_count = u32;
+	if (__ni_objectmodel_dict_get_hwaddr(dict, "perm-hwaddr", &info->perm_hwaddr)) {
+		if (info->perm_hwaddr.len == ni_link_address_length(ARPHRD_INFINIBAND))
+			info->perm_hwaddr.type = ARPHRD_INFINIBAND;
+		else if (info->perm_hwaddr.len == ni_link_address_length(ARPHRD_ETHER))
+			info->perm_hwaddr.type = ARPHRD_ETHER;
+		else
+			info->perm_hwaddr.type = ARPHRD_VOID;
 	}
+	if (ni_dbus_dict_get_uint16(dict, "queue-id", &u16))
+		info->queue_id = u16;
+	if (ni_dbus_dict_get_uint16(dict, "ad-aggregator-id", &u16))
+		info->ad_aggregator_id = u16;
+
 	return TRUE;
 }
 
@@ -676,15 +592,13 @@ static ni_dbus_property_t	ni_objectmodel_bond_properties[] = {
 	BONDING_UINT_PROPERTY(num-grat-arp, num_grat_arp, RO),
 	BONDING_UINT_PROPERTY(num-unsol-na, num_unsol_na, RO),
 	BONDING_UINT_PROPERTY(fail-over-mac, fail_over_mac, RO),
+	BONDING_STRING_PROPERTY(primary, primary_slave.name, RO),
 	BONDING_UINT_PROPERTY(primary-reselect, primary_reselect, RO),
 	BONDING_BOOL_PROPERTY(all-slaves-active, all_slaves_active, RO),
 	BONDING_UINT_PROPERTY(packets-per-slave, packets_per_slave, RO),
 	BONDING_BOOL_PROPERTY(tlb-dynamic-lb, tlb_dynamic_lb, RO),
 	BONDING_UINT_PROPERTY(lp-interval, lp_interval, RO),
 
-	__NI_DBUS_PROPERTY(
-			DBUS_TYPE_ARRAY_AS_STRING NI_DBUS_DICT_SIGNATURE,
-			slaves, __ni_objectmodel_bonding, RO),
 	__NI_DBUS_PROPERTY(
 			NI_DBUS_DICT_SIGNATURE,
 			miimon, __ni_objectmodel_bonding, RO),
diff --git a/src/dbus-objects/bridge.c b/src/dbus-objects/bridge.c
index 8ee6554fb..bb6f960b5 100644
--- a/src/dbus-objects/bridge.c
+++ b/src/dbus-objects/bridge.c
@@ -29,14 +29,6 @@
 #include "debug.h"
 
 static ni_netdev_t *	__ni_objectmodel_bridge_newlink(ni_netdev_t *, const char *, DBusError *);
-static dbus_bool_t	__ni_objectmodel_bridge_port_to_dict(const ni_bridge_port_t *port,
-				ni_dbus_variant_t *dict,
-				const ni_dbus_object_t *object,
-				int config_only);
-static dbus_bool_t	__ni_objectmodel_bridge_port_from_dict(ni_bridge_port_t *port,
-				const ni_dbus_variant_t *dict,
-				DBusError *error,
-				int config_only);
 
 /*
  * Return an interface handle containing all bridge-specific information provided
@@ -237,18 +229,6 @@ __ni_objectmodel_bridge_handle(const ni_dbus_object_t *object, ni_bool_t write_a
 	return bridge;
 }
 
-static ni_bridge_t *
-__ni_objectmodel_bridge_write_handle(const ni_dbus_object_t *object, DBusError *error)
-{
-	return __ni_objectmodel_bridge_handle(object, TRUE, error);
-}
-
-static const ni_bridge_t *
-__ni_objectmodel_bridge_read_handle(const ni_dbus_object_t *object, DBusError *error)
-{
-	return __ni_objectmodel_bridge_handle(object, FALSE, error);
-}
-
 void *
 ni_objectmodel_get_bridge(const ni_dbus_object_t *object, ni_bool_t write_access, DBusError *error)
 {
@@ -256,131 +236,99 @@ ni_objectmodel_get_bridge(const ni_dbus_object_t *object, ni_bool_t write_access
 }
 
 /*
- * Property ports
+ * Bridge port (link-request) configuration
  */
-static dbus_bool_t
-__ni_objectmodel_bridge_get_ports(const ni_dbus_object_t *object, const ni_dbus_property_t *property,
-				ni_dbus_variant_t *result, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_get_bridge_port_config(const ni_bridge_port_config_t *conf,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
-	const ni_bridge_t *bridge;
-	unsigned int i;
+	(void)error;
 
-	if (!(bridge = __ni_objectmodel_bridge_read_handle(object, error)))
+	if (!conf || !dict)
 		return FALSE;
 
-	ni_dbus_dict_array_init(result);
-	for (i = 0; i < bridge->ports.count; ++i) {
-		const ni_bridge_port_t *port = bridge->ports.data[i];
-		ni_dbus_variant_t *dict;
-
-		/* Append a new element to the array */
-		if (!(dict = ni_dbus_dict_array_add(result)))
-			return FALSE;
-		ni_dbus_variant_init_dict(dict);
+	if (conf->priority != NI_BRIDGE_VALUE_NOT_SET)
+		ni_dbus_dict_add_uint32(dict, "priority", conf->priority);
+	if (conf->path_cost != NI_BRIDGE_VALUE_NOT_SET)
+		ni_dbus_dict_add_uint32(dict, "path-cost", conf->path_cost);
 
-		if (!__ni_objectmodel_bridge_port_to_dict(port, dict, object, 0))
-			return FALSE;
-	}
 	return TRUE;
 }
-
-static dbus_bool_t
-__ni_objectmodel_bridge_set_ports(ni_dbus_object_t *object, const ni_dbus_property_t *property,
-				const ni_dbus_variant_t *argument, DBusError *error)
+extern dbus_bool_t
+ni_objectmodel_set_bridge_port_config(ni_bridge_port_config_t *conf,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
-	ni_dbus_variant_t *port_dict;
-	ni_bridge_t *bridge;
-	unsigned int i;
+	uint32_t value;
 
-	if (!(bridge = __ni_objectmodel_bridge_write_handle(object, error)))
-		return FALSE;
+	(void)error;
 
-	if (!ni_dbus_variant_is_dict_array(argument))
+	if (!conf || !dict)
 		return FALSE;
 
-	port_dict = argument->variant_array_value;
-	for (i = 0; i < argument->array.len; ++i, ++port_dict) {
-		ni_bridge_port_t *port;
-
-		port = ni_bridge_port_new(NULL, NULL, 0);
-		if (!__ni_objectmodel_bridge_port_from_dict(port, port_dict, error, TRUE)) {
-			ni_bridge_port_free(port);
-			return FALSE;
-		}
-
-		if (ni_bridge_add_port(bridge, port) < 0) {
-			ni_bridge_port_free(port); /* duplicate port */
-		}
-	}
+	if (ni_dbus_dict_get_uint32(dict, "priority", &value))
+		conf->priority = value;
+	if (ni_dbus_dict_get_uint32(dict, "path-cost", &value))
+		conf->path_cost = value;
 
 	return TRUE;
 }
 
 /*
- * Helper functions to represent ports as a dbus dict
+ * Bridge port interface info properties
  */
-static dbus_bool_t
-__ni_objectmodel_bridge_port_to_dict(const ni_bridge_port_t *port, ni_dbus_variant_t *dict,
-				const ni_dbus_object_t *object,
-				int config_only)
+extern dbus_bool_t
+ni_objectmodel_get_bridge_port_info(const ni_bridge_port_info_t *info,
+		ni_dbus_variant_t *dict, DBusError *error)
 {
-	/*
-	 * Hmm... Resolving the complete tree and ports to devices
-	 * while serializing at client side does not work properly,
-	 * e.g. when the port does not exists yet...
-	 *
-	 * FIXME: should we resolve the object path here?
-	 */
-	if (ni_string_empty(port->ifname))
-		return FALSE;
+	(void)error;
 
-	ni_dbus_dict_add_string(dict, "device", port->ifname);
-	ni_dbus_dict_add_uint32(dict, "priority", port->priority);
-	ni_dbus_dict_add_uint32(dict, "path-cost", port->path_cost);
+	if (!info || !dict)
+		return FALSE;
 
-	if (config_only)
-		return TRUE;
+	if (info->state)
+		ni_dbus_dict_add_uint32(dict, "state", info->state);
+	if (info->port_no)
+		ni_dbus_dict_add_uint32(dict, "port-no", info->port_no);
+	if (info->port_id)
+		ni_dbus_dict_add_uint32(dict, "port-id", info->port_id);
 
-	ni_dbus_dict_add_uint32(dict, "state", port->status.state);
-	ni_dbus_dict_add_uint32(dict, "port-id", port->status.port_id);
-	ni_dbus_dict_add_uint32(dict, "port-no", port->status.port_no);
+	if (info->priority != NI_BRIDGE_VALUE_NOT_SET)
+		ni_dbus_dict_add_uint32(dict, "priority", info->priority);
+	if (info->path_cost != NI_BRIDGE_VALUE_NOT_SET)
+		ni_dbus_dict_add_uint32(dict, "path-cost", info->path_cost);
 
 	return TRUE;
 }
 
-static dbus_bool_t
-__ni_objectmodel_bridge_port_from_dict(ni_bridge_port_t *port, const ni_dbus_variant_t *dict,
-				DBusError *error,
-				int config_only)
+extern dbus_bool_t
+ni_objectmodel_set_bridge_port_info(ni_bridge_port_info_t *info,
+		const ni_dbus_variant_t *dict, DBusError *error)
 {
-	const char *string;
 	uint32_t value;
 
-	if (dict->array.len == 0)
-		return TRUE;
+	(void)error;
 
-	/* FIXME: should expect object path here and map that to an ifindex */
-	if (ni_dbus_dict_get_string(dict, "device", &string) && !ni_string_empty(string))
-		ni_string_dup(&port->ifname, string);
-	else
+	if (!info || !dict)
 		return FALSE;
 
-	if (ni_dbus_dict_get_uint32(dict, "priority", &value))
-		port->priority = value;
-	if (ni_dbus_dict_get_uint32(dict, "path-cost", &value))
-		port->path_cost = value;
-
-	/* FIXME: Really? I don't think so... */
 	if (ni_dbus_dict_get_uint32(dict, "state", &value))
-		port->status.state = value;
-	if (ni_dbus_dict_get_uint32(dict, "port-id", &value))
-		port->status.port_id = value;
+		info->state = value;
 	if (ni_dbus_dict_get_uint32(dict, "port-no", &value))
-		port->status.port_no = value;
+		info->port_no = value;
+	if (ni_dbus_dict_get_uint32(dict, "port-id", &value))
+		info->port_id = value;
+
+	if (ni_dbus_dict_get_uint32(dict, "priority", &value))
+		info->priority = value;
+	if (ni_dbus_dict_get_uint32(dict, "path-cost", &value))
+		info->path_cost = value;
 
 	return TRUE;
 }
 
+/*
+ * Additional, not bridge-specific MAC/HW-Address property
+ */
 static dbus_bool_t
 ni_objectmodel_bridge_get_address(const ni_dbus_object_t *object,
 				const ni_dbus_property_t *property,
@@ -432,10 +380,6 @@ static const ni_dbus_property_t	ni_objectmodel_bridge_property_table[] = {
 	BRIDGE_TIME_PROPERTY(hello-time, hello_time, RO),
 	BRIDGE_TIME_PROPERTY(max-age, max_age, RO),
 
-	/* ports is an array of dicts */
-	WICKED_BRIDGE_PROPERTY_SIGNATURE(DBUS_TYPE_ARRAY_AS_STRING NI_DBUS_DICT_SIGNATURE,
-			ports, RO),
-
 	BRIDGE_HWADDR_PROPERTY(address, RO),
 
 	{ NULL }
diff --git a/src/dbus-objects/interface.c b/src/dbus-objects/interface.c
index 86014c08a..00e8fb118 100644
--- a/src/dbus-objects/interface.c
+++ b/src/dbus-objects/interface.c
@@ -1498,7 +1498,7 @@ ni_objectmodel_netif_client_state_control_to_dict(const ni_client_state_control_
 
 	if (ni_tristate_is_set(ctrl->require_link)) {
 		if (!ni_dbus_dict_add_bool(var, NI_CLIENT_STATE_XML_REQUIRE_LINK_NODE,
-			(dbus_bool_t) ni_tristate_is_disabled(ctrl->require_link))) {
+			(dbus_bool_t) ni_tristate_is_enabled(ctrl->require_link))) {
 			return FALSE;
 		}
 	}
@@ -1683,12 +1683,159 @@ ni_objectmodel_netif_client_state_scripts_from_dict(ni_client_state_scripts_t *s
 	return TRUE;
 }
 
+static dbus_bool_t
+ni_objectmodel_netif_get_master(const ni_dbus_object_t *object,
+		const ni_dbus_property_t *property,
+		ni_dbus_variant_t *result,
+		DBusError *error)
+{
+	const ni_netdev_ref_t *ref;
+	const ni_netdev_t *dev;
+
+	if (!(dev = ni_dbus_object_get_handle(object)))
+		return FALSE;
+
+	ref = ni_netdev_get_master_ref(dev);
+	if (!ref || ni_string_empty(ref->name))
+		return FALSE;
+
+	ni_dbus_variant_set_string(result, ref->name);
+	return TRUE;
+}
+static dbus_bool_t
+ni_objectmodel_netif_set_master(ni_dbus_object_t *object,
+		const ni_dbus_property_t *property,
+		const ni_dbus_variant_t *argument,
+		DBusError *error)
+{
+	const char *str = NULL;
+	ni_netdev_t *dev;
+
+	if (!(dev = ni_dbus_object_get_handle(object)))
+		return FALSE;
+
+	if (ni_dbus_variant_get_string(argument, &str))
+		return ni_netdev_ref_set(&dev->link.masterdev, str, 0);
+
+	ni_netdev_ref_destroy(&dev->link.masterdev);
+	return TRUE;
+}
+
+static inline ni_dbus_variant_t *
+ni_objectmodel_netif_port_union_init(ni_dbus_variant_t *result, ni_iftype_t type)
+{
+	ni_dbus_variant_t *dict;
+	const char *name;
+
+	name = ni_linktype_type_to_name(type);
+	if (!result || !name)
+		return NULL;
+
+	ni_dbus_variant_init_struct(result);
+	ni_dbus_struct_add_string(result, name);
+	if ((dict = ni_dbus_struct_add(result)))
+		ni_dbus_variant_init_dict(dict);
+	return dict;
+}
+
+static dbus_bool_t
+ni_objectmodel_netif_get_port(const ni_dbus_object_t *object,
+		const ni_dbus_property_t *property,
+		ni_dbus_variant_t *result,
+		DBusError *error)
+{
+	ni_dbus_variant_t *dict;
+	ni_netdev_t *dev;
+
+	if (!(dev = ni_dbus_object_get_handle(object)))
+		return FALSE;
+
+	switch (dev->link.port.type) {
+	case NI_IFTYPE_BOND:
+		if (!(dict = ni_objectmodel_netif_port_union_init(result, dev->link.port.type)))
+			return FALSE;
+		return ni_objectmodel_get_bonding_port_info(dev->link.port.bond, dict, error);
+
+	case NI_IFTYPE_TEAM:
+		if (!(dict = ni_objectmodel_netif_port_union_init(result, dev->link.port.type)))
+			return FALSE;
+		return ni_objectmodel_get_team_port_info(dev->link.port.team, dict, error);
+
+	case NI_IFTYPE_BRIDGE:
+		if (!(dict = ni_objectmodel_netif_port_union_init(result, dev->link.port.type)))
+			return FALSE;
+		return ni_objectmodel_get_bridge_port_info(dev->link.port.bridge, dict, error);
+
+	case NI_IFTYPE_OVS_BRIDGE:
+		if (!(dict = ni_objectmodel_netif_port_union_init(result, dev->link.port.type)))
+			return FALSE;
+		return ni_objectmodel_get_ovs_bridge_port_info(dev->link.port.ovsbr, dict, error);
+
+	default:
+		return ni_dbus_error_property_not_present(error, object->path, property->name);
+	}
+}
+static dbus_bool_t
+ni_objectmodel_netif_set_port(ni_dbus_object_t *object,
+		const ni_dbus_property_t *property,
+		const ni_dbus_variant_t *argument,
+		DBusError *error)
+{
+	const ni_dbus_variant_t *dict;
+	ni_netdev_t *dev;
+	const char *name;
+
+	if (!(dev = ni_dbus_object_get_handle(object)))
+		return FALSE;
+
+	/* make sure we clear previously applied port info */
+	ni_netdev_port_info_destroy(&dev->link.port);
+
+	if (!ni_dbus_struct_get_string(argument, 0, &name) || ni_string_empty(name)) {
+		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
+				"missing union switch type in property %s.%s",
+				object->path, property->name);
+		return FALSE;
+	}
+	if (!(dict = ni_dbus_struct_get(argument, 1)) || !ni_dbus_variant_is_dict(dict)) {
+		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
+				"missing %s union data dict in property %s.%s",
+				name, object->path, property->name);
+		return FALSE;
+	}
+
+	if (!ni_netdev_port_info_data_init(&dev->link.port, ni_linktype_name_to_type(name)))
+		return FALSE;
+
+	switch (dev->link.port.type) {
+	case NI_IFTYPE_BOND:
+		return ni_objectmodel_set_bonding_port_info(dev->link.port.bond, dict, error);
+
+	case NI_IFTYPE_TEAM:
+		return ni_objectmodel_set_team_port_info(dev->link.port.team, dict, error);
+
+	case NI_IFTYPE_BRIDGE:
+		return ni_objectmodel_set_bridge_port_info(dev->link.port.bridge, dict, error);
+
+	case NI_IFTYPE_OVS_BRIDGE:
+		return ni_objectmodel_set_ovs_bridge_port_info(dev->link.port.ovsbr, dict, error);
+
+	default:
+		return FALSE;
+	}
+}
 
 /*
  * Properties of an interface
  */
 #define NETIF_PROPERTY_SIGNATURE(signature, __name, rw) \
 	__NI_DBUS_PROPERTY(signature, __name, __ni_objectmodel_netif, rw)
+#define NETIF_MASTER_DEVICE_PROPERTY(dbus_name, type_name, rw) \
+	___NI_DBUS_PROPERTY(NI_DBUS_SIGNATURE(STRING), dbus_name, type_name, \
+				ni_objectmodel_netif, rw)
+#define NETIF_PORT_INFO_UNION_PROPERTY(dbus_name, type_name, rw) \
+	___NI_DBUS_PROPERTY(NI_DBUS_DICT_SIGNATURE, dbus_name, type_name, \
+				ni_objectmodel_netif, rw)
 
 static ni_dbus_property_t	ni_objectmodel_netif_properties[] = {
 	NI_DBUS_GENERIC_STRING_PROPERTY(netdev, name, name, RO),
@@ -1698,7 +1845,8 @@ static ni_dbus_property_t	ni_objectmodel_netif_properties[] = {
 	NI_DBUS_GENERIC_UINT_PROPERTY(netdev, mtu, link.mtu, RO),
 	NI_DBUS_GENERIC_UINT_PROPERTY(netdev, txqlen, link.txqlen, RO),
 	NI_DBUS_GENERIC_STRING_PROPERTY(netdev, alias, link.alias, RO),
-	NI_DBUS_GENERIC_STRING_PROPERTY(netdev, master, link.masterdev.name, RO),
+	NETIF_MASTER_DEVICE_PROPERTY(master, master, RO),
+	NETIF_PORT_INFO_UNION_PROPERTY(port, port, RO),
 
 	___NI_DBUS_PROPERTY(NI_DBUS_DICT_SIGNATURE,
 				client-state, client_state,
@@ -1728,59 +1876,63 @@ ni_objectmodel_get_netdev_req(const ni_dbus_object_t *object, ni_bool_t write_ac
 	return ni_dbus_object_get_handle(object);
 }
 
+static inline ni_dbus_variant_t *
+ni_objectmodel_netdev_req_port_union_init(ni_dbus_variant_t *result, ni_iftype_t type)
+{
+	ni_dbus_variant_t *dict;
+	const char *name;
+
+	name = ni_linktype_type_to_name(type);
+	if (!result || !name)
+		return NULL;
+
+	ni_dbus_variant_init_struct(result);
+	ni_dbus_struct_add_string(result, name);
+	if ((dict = ni_dbus_struct_add(result)))
+		ni_dbus_variant_init_dict(dict);
+	return dict;
+}
+
 static dbus_bool_t
 __ni_objectmodel_netdev_req_get_port(const ni_dbus_object_t *object, const ni_dbus_property_t *property,
 					ni_dbus_variant_t *result, DBusError *error)
 {
 	const ni_netdev_req_t *req;
 	ni_dbus_variant_t *dict;
-	const char *name;
 
 	if (!(req = ni_objectmodel_unwrap_netif_request(object, error)))
 		return FALSE;
-	if (!req->port)
-		return FALSE;
 
-	switch (req->port->type) {
-	case NI_IFTYPE_TEAM:
+	switch (req->port.type) {
 	case NI_IFTYPE_BOND:
-	case NI_IFTYPE_BRIDGE:
-	case NI_IFTYPE_OVS_BRIDGE:
-		if ((name = ni_linktype_type_to_name(req->port->type)))
-			break;
-		/* fall through */
-	default:
-		return ni_dbus_error_property_not_present(error, object->path, property->name);
-	}
+		if (!(dict = ni_objectmodel_netdev_req_port_union_init(result, req->port.type)))
+			return FALSE;
 
-	ni_dbus_variant_init_struct(result);
-	ni_dbus_struct_add_string(result, name);
-	dict = ni_dbus_struct_add(result);
-	ni_dbus_variant_init_dict(dict);
+		return ni_objectmodel_get_bonding_port_config(req->port.bond, dict, error);
 
-	switch (req->port->type) {
-	case NI_IFTYPE_TEAM: {
-			const ni_team_port_config_t *pconf = &req->port->team;
+	case NI_IFTYPE_TEAM:
+		if (!(dict = ni_objectmodel_netdev_req_port_union_init(result, req->port.type)))
+			return FALSE;
 
-			if (!__ni_objectmodel_get_team_port_config(pconf, dict, error))
-				return FALSE;
-		}
-		break;
+		return ni_objectmodel_get_team_port_config(req->port.team, dict, error);
 
-	case NI_IFTYPE_OVS_BRIDGE: {
-			const ni_ovs_bridge_port_config_t *pconf = &req->port->ovsbr;
+	case NI_IFTYPE_BRIDGE:
+		if (!(dict = ni_objectmodel_netdev_req_port_union_init(result, req->port.type)))
+			return FALSE;
 
-			if (!__ni_objectmodel_get_ovs_bridge_port_config(pconf, dict, error))
-				return FALSE;
-		}
-		break;
+		return ni_objectmodel_get_bridge_port_config(req->port.bridge, dict, error);
+
+	case NI_IFTYPE_OVS_BRIDGE:
+		if (!(dict = ni_objectmodel_netdev_req_port_union_init(result, req->port.type)))
+			return FALSE;
+
+		return ni_objectmodel_get_ovs_bridge_port_config(req->port.ovsbr, dict, error);
 
-	case NI_IFTYPE_BOND:
-	case NI_IFTYPE_BRIDGE:
 	default:
 		break;
 	}
-	return TRUE;
+
+	return ni_dbus_error_property_not_present(error, object->path, property->name);
 }
 
 static dbus_bool_t
@@ -1790,70 +1942,51 @@ __ni_objectmodel_netdev_req_set_port(ni_dbus_object_t *object, const ni_dbus_pro
 	const ni_dbus_variant_t *dict;
 	ni_netdev_req_t *req;
 	const char *name;
-	ni_iftype_t type;
 
 	if (!(req = ni_objectmodel_unwrap_netif_request(object, error)))
 		return FALSE;
 
+	/*
+	 * this should not happen, but make sure we clear
+	 * previously applied netdev request port config
+	 */
+	ni_netdev_port_config_destroy(&req->port);
+
 	if (!ni_dbus_struct_get_string(argument, 0, &name)) {
 		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-				"bad value for property %s; missed type", property->name);
+				"missing union switch type in property %s.%s",
+				object->path, property->name);
 		return FALSE;
 	}
-
-	type = ni_linktype_name_to_type(name);
-	switch (type) {
-	case NI_IFTYPE_TEAM:
-	case NI_IFTYPE_BOND:
-	case NI_IFTYPE_BRIDGE:
-	case NI_IFTYPE_OVS_BRIDGE:
-		break;
-	default:
+	if (!(dict = ni_dbus_struct_get(argument, 1)) || !ni_dbus_variant_is_dict(dict)) {
 		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
-				"bad value for property %s; unsupported type %s", property->name, name);
-		return FALSE;
-	}
-
-	if (!(dict = ni_dbus_struct_get(argument, 1))) {
-		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS, "missed netdev request port member dict");
-		return FALSE;
-	}
-	if (!ni_dbus_variant_is_dict(dict)) {
-		dbus_set_error(error, DBUS_ERROR_INVALID_ARGS, "netdev request port data is not a dict");
-		return FALSE;
-	}
-
-	if (req->port)
-		ni_netdev_port_req_free(req->port);
-	if (!(req->port = ni_netdev_port_req_new(type))) {
-		dbus_set_error(error, DBUS_ERROR_FAILED, "unable to allocate netdev request %s port data", name);
+				"missing union data dict in property %s.%s",
+				object->path, property->name);
 		return FALSE;
 	}
 
-	switch (req->port->type) {
-	case NI_IFTYPE_TEAM: {
-			ni_team_port_config_t *pconf = &req->port->team;
+	ni_netdev_port_config_init(&req->port, ni_linktype_name_to_type(name));
+	switch (req->port.type) {
+	case NI_IFTYPE_BOND:
+		return ni_objectmodel_set_bonding_port_config(req->port.bond, dict, error);
 
-			if (!__ni_objectmodel_set_team_port_config(pconf, dict, error))
-				return FALSE;
-		}
-		break;
+	case NI_IFTYPE_TEAM:
+		return ni_objectmodel_set_team_port_config(req->port.team, dict, error);
 
-	case NI_IFTYPE_OVS_BRIDGE: {
-			ni_ovs_bridge_port_config_t *pconf = &req->port->ovsbr;
+	case NI_IFTYPE_BRIDGE:
+		return ni_objectmodel_set_bridge_port_config(req->port.bridge, dict, error);
 
-			if (!__ni_objectmodel_set_ovs_bridge_port_config(pconf, dict, error))
-				return FALSE;
-		}
-		break;
+	case NI_IFTYPE_OVS_BRIDGE:
+		return ni_objectmodel_set_ovs_bridge_port_config(req->port.ovsbr, dict, error);
 
-	case NI_IFTYPE_BOND:
-	case NI_IFTYPE_BRIDGE:
 	default:
-		dbus_set_error(error, DBUS_ERROR_FAILED, "unable to initialize netdev request %s port data", name);
-		return FALSE;
+		break;
 	}
-	return TRUE;
+
+	dbus_set_error(error, DBUS_ERROR_INVALID_ARGS,
+			"unable to set netdev request %s port config from property %s.%s",
+			name, object->path, property->name);
+	return FALSE;
 }
 
 #define NETIF_REQUEST_UINT_PROPERTY(dbus_name, name, rw) \
diff --git a/src/dbus-objects/model.c b/src/dbus-objects/model.c
index 9f5d871fb..694050f61 100644
--- a/src/dbus-objects/model.c
+++ b/src/dbus-objects/model.c
@@ -55,6 +55,18 @@ static ni_dbus_service_t	ni_objectmodel_netif_root_interface;
 ni_dbus_server_t *		__ni_objectmodel_server;
 ni_xs_scope_t *			__ni_objectmodel_schema;
 
+extern unsigned int
+ni_objectmodel_class_registry_count(void)
+{
+	return ni_objectmodel_class_registry.count;
+}
+
+extern unsigned int
+ni_objectmodel_service_registry_count(void)
+{
+	return ni_objectmodel_service_registry.count;
+}
+
 /*
  * Create the dbus service
  */
